#include "gaunt.h"

int imax(int x,int y) {
  return ( (x>=y) ? x : y );
}

int imin(int x,int y) {
  return ( (x>=y) ? y : x );
}

int iceil(int x,int y) {
  int res;
  res = x/y;
  if (res*y<x) res++;
  return res;
}

unsigned long fN1(int l)
{
   unsigned long x;
   x = (l+1)*(l+2)*(l+3)*(l+4);
   return(x/24);
}

unsigned long fM1(int l)
{
  unsigned long x;
  x = l;
  if (l%2==0) 
    x = (l+2)*(l+4)*(((18*l +97)*l + 214)*l+120);
  else
    x = (l+1)*(l+3)*(l+5)*((18*l+43)*l + 19);
  return(x/960);
}

unsigned long fN2(int l)
{
  unsigned long x;
  x = l;
  if (l%2==0) 
    x = (l+2)*(l+4)*((3*l +14)*l + 24);
  else
    x = (l+1)*(l+3)*(l+5)*(3*l + 5);
  return(x/192);
}

unsigned long fN3bar(int l)
{
  unsigned long x;
  x = l;
  if (l%2==0) 
    x = (x+2)*(x+3)*(x+4);
  else 
    x = (x+1)*(x+3)*(x+5);
  return(x/24);
} 

unsigned long fN3(int l)
{
  unsigned long x;
  x = l;
  if (l%2==0) 
    x = (x+2)*(x+4)*((5*x +30)*x + 48);
  else {
    if (l%4==1)
       x = (x+3)*(x+3)*((5*x+30)*x+13);
    else   
       x = (x+1)*(x+5)*((5*x+30)*x+33);
    }
  return(x/384);
}
/*
int istriangle(int l1,int l2,int l3)
{
    if ( l1 > l2+l3 || l2<abs(l1-l3) || l3<abs(l1-l2) || l1<abs(l2-l3) || l2>l1+l3  || l3>l1+l2 )
      return 1;
    return 0;
}
*/
int istriangle(int l1,int l2,int l3)
{
    if ( l1 > l2+l3 || l2>l1+l3  || l3>l1+l2 )
      return 1;
    return 0;
}
